import { Component, ViewChild, ViewContainerRef, ReflectiveInjector, ComponentFactoryResolver, Input } from '@angular/core';
import { EJComponents } from './../../../node_modules/ej-angular2/src/ej/core';
import { GridComponent } from './../grid/grid.component';

@Component({
  selector: 'ej-app',
  templateUrl: './home.component.html',
  entryComponents: [GridComponent]
})

export class HomeComponent {
  // tab containers
  @ViewChild('tabContent0', { read: ViewContainerRef }) tabContent0: ViewContainerRef;
  @ViewChild('tabContent1', { read: ViewContainerRef }) tabContent1: ViewContainerRef;
  @ViewChild('tabContent2', { read: ViewContainerRef }) tabContent2: ViewContainerRef;
  @ViewChild('tabContent3', { read: ViewContainerRef }) tabContent3: ViewContainerRef;
  @ViewChild('tabContent4', { read: ViewContainerRef }) tabContent4: ViewContainerRef;
  @ViewChild('tabContent5', { read: ViewContainerRef }) tabContent5: ViewContainerRef;
  @ViewChild('tabContent6', { read: ViewContainerRef }) tabContent6: ViewContainerRef;
  @ViewChild('tabContent7', { read: ViewContainerRef }) tabContent7: ViewContainerRef;
  @ViewChild('tabContent8', { read: ViewContainerRef }) tabContent8: ViewContainerRef;
  @ViewChild('tabContent9', { read: ViewContainerRef }) tabContent9: ViewContainerRef;
  @ViewChild('tabContent10', { read: ViewContainerRef }) tabContent10: ViewContainerRef;

  tabComponents = {};
  usedTabs = {};
  currentTabId = "tabContent0";
  hiddenTabs: Array<number>;
  @Input() tabPanelName: string;

  // Other
  @ViewChild('myTabPanel') gpTabPanel: EJComponents<ej.Tab, any>;

  constructor(private resolver: ComponentFactoryResolver) {
    this.hiddenTabs = Array<number>();
    let a =new TabDataComponent();
    debugger
    console.log(a.tab);
  }

  tempTestCounter = 0;
  onCustomButtonClick(args) {
    this.tempTestCounter++;
    this.createNewTab('homeComponent' + this.tempTestCounter, 'test' + this.tempTestCounter, {});
  }


  // When creating new tab
  public createNewTab(componentModulePath, tabName, componentInputs) {

    var tN = tabName;
    if (tabName == '')
      tN = 'noName';
    var id = componentInputs['RecordId'];

    if (id)
      id = id['RecordId'];
    var tId = componentModulePath + id;

    // Checking if tab is already opened and if so, focusing
    if (this.usedTabs[tId] && this.tabComponents[this.usedTabs[tId]] && this.tabComponents[this.usedTabs[tId]] != null) {
      var tabNumber = this.usedTabs[tId].replace(/\D/g, '');
      this.gpTabPanel.widget.showItem(tabNumber);
      return;
    }

    console.log('c');
    console.log(this.hiddenTabs);
    // If any unused tab exist, use it
    if (this.hiddenTabs.length > 0) {

      console.log('c');
      var htId = this.hiddenTabs.shift();

      $("#myTabPanel").ejTab({ hiddenItemIndex: this.hiddenTabs });
      this.gpTabPanel.widget.showItem(htId);

      // Loading and inserting
      this.loadComponentAndInsert(componentModulePath, 'tabContent' + htId, componentInputs);

      return;
    }

    // Checking if opened tab limit is not reached and creating new tab
    if (this.isTabLimitNotReached()) {
      // Preparing
      var tabId = this.createTab(tabName);
      this.usedTabs[tId] = tabId;

      // Loading and inserting
      this.loadComponentAndInsert(componentModulePath, tabId, componentInputs);
    }
    else
      console.log('Not able to create more than 10 tabs!');
  }

  // Is Tab limit reached
  private isTabLimitNotReached() {
    // Visible tabs count
    var tabCount = this.gpTabPanel.widget.getItemsCount();

    if (tabCount < 11)
      return true;
    else
      if (this.hiddenTabs.length > 0)
        return true;
      else
        return false;
  }

  //Create new tab
  private createTab(tabName) {
    // Tab control
    var tabObj = this.gpTabPanel.widget;

    // Visible tabs count
    var tabCount = tabObj.getItemsCount();

    // Adding tab (url, displayLabel, index, cssClass, id)
    var isHiddenTab = this.hiddenTabs.length > 0;
    var tabIdNumber = this.getTabId();
    var tabId = 'tabContent' + tabIdNumber;

    if (tabId === "tabContent11")
      return;

    if (!isHiddenTab)
      tabObj.addItem(tabId, tabName, tabCount + 1, null, tabId);
    // $("#"+tabId).html("<div id=\"" + tabId +"\" style=\"background-color: deeppink\"><div #" + tabId +"></div></div>");

    // Activating tab
    tabObj.showItem(tabIdNumber);
    //   this.resizeContent(this._contentHeight);

    return tabId;
  }

  private getTabId() {
    // Tab control
    var tabObj = this.gpTabPanel.widget;

    if (this.hiddenTabs.length > 0) {
      var id = this.hiddenTabs.shift();

      tabObj.showItem(id);
      $("#myTabPanel").ejTab({ hiddenItemIndex: this.hiddenTabs });
      //tabObj.model.hiddenItemIndex = this.hiddenTabs;

      return id;
    }

    // Visible tabs count
    var tabCount = tabObj.getItemsCount();
    // Adding tab (url, displayLabel, index, cssClass, id)
    var tabId = tabCount;

    return tabId;
  }

  // Load component into Tab
  private loadComponentAndInsert(componentName, tabId, inputData) {

    // Choosing where to insert component
    var vcRef: ViewContainerRef;

    switch (tabId) {
      case 'tabContent1': vcRef = this.tabContent1; break;
      case 'tabContent2': vcRef = this.tabContent2; break;
      case 'tabContent3': vcRef = this.tabContent3; break;
      case 'tabContent4': vcRef = this.tabContent4; break;
      case 'tabContent5': vcRef = this.tabContent5; break;
      case 'tabContent6': vcRef = this.tabContent6; break;
      case 'tabContent7': vcRef = this.tabContent7; break;
      case 'tabContent8': vcRef = this.tabContent8; break;
      case 'tabContent9': vcRef = this.tabContent9; break;
      case 'tabContent10': vcRef = this.tabContent10; break;
      default: console.log('Not able to create more than 10 tabs!'); break;
    }

    if (!vcRef) {
      console.log('[ERROR] View container is not selected in gpMain!');
      return;
    }
 
    // Choosing which component to load
    var component: any;

    switch (componentName) {
      default: component = GridComponent; console.log('ERROR -!- Can\' find suitable component! (' + componentName + ')'); break;
    }


    // Inputs need to be in the following format to be resolved properly
    let inputProviders = Object.keys(inputData).map((inputName) => { return { provide: inputName, useValue: inputData[inputName] }; });
    let resolvedInputs = ReflectiveInjector.resolve(inputProviders);

    // We create an injector out of the data we want to pass down and this components injector
    let injector = ReflectiveInjector.fromResolvedProviders(resolvedInputs, vcRef.parentInjector);

    // We create a factory out of the component we want to create
    let factory = this.resolver.resolveComponentFactory(component);

    // We create the component using the factory and the injector
    let comp = factory.create(injector);

    // We insert the component into the dom container
    vcRef.insert(comp.hostView);

    this.tabComponents[tabId] = comp;

  }

  // When 'X' on Tab is Clicked
  private onBeforeTabItemRemvove(args) {
    var comp = this.tabComponents["tabContent" + args.index];
    comp.destroy();
    this.tabComponents["tabContent" + args.index] = null;

    delete this.usedTabs["tabContent" + args.index];
    this.hiddenTabs.push(args.index);

    this.gpTabPanel.widget.showItem(1)

    $("#myTabPanel").ejTab({ hiddenItemIndex: this.hiddenTabs });


    var ab = args;
    ab.cancel = true;

    return ab;
  }

  // After new tab is selected, inform dialog list about change
  private onBeforeTabItemActive(args) {
    var newTab = "tabContent" + args.activeIndex;

    this.currentTabId = newTab;
  }

}
export class TabDataComponent {
  public tab:string;
  constructor() {
    debugger;
    this.tab = 'hello';

  }
}
